using System;
namespace MyOutlookAddin1
{
	/// <summary>
	/// Summary description for ADXOlForm1.
	/// </summary>
	public partial class ADXOlForm1 : AddinExpress.OL.ADXOlForm, Logging.ILogPane
	{
		private bool letMeShow = true;
		static int ID = 0;
		private int id = 0;
		public ADXOlForm1()
		{
			InitializeComponent();
			id = ID++;
			Logging.Log.Add(this.ToString(), "New instance created");
			this.label1.Text = "Id=" + id.ToString();
			//this.logPaneManager = MyOutlookAddin1.AddinModule.CurrentInstance as Logging.ILogPaneManager;
		}

		#region Events of Add-in Express panes
		private void ADXOlForm1_ADXBeforeFormShow()
		{
			this.logPaneManager = this.AddinModule as Logging.ILogPaneManager;
			this.Visible = letMeShow;
			if (!letMeShow)
            {
				Logging.Log.Add(this.ToString(), "ADXBeforeFormShow. Pane won't show.");
			}
		}
		private void ADXOlForm1_ADXAfterFormShow()
		{
			// see ADXOlForm1_ADXPostMessageReceived()
			this.ADXPostMessage(IntPtr.Zero, IntPtr.Zero);
			this.ADXPostMessage(IntPtr.Zero, (IntPtr)1);
		}
		private void ADXOlForm1_ADXAfterFormHide(object sender, ADXAfterFormHideEventArgs e)
		{
			logPaneManager.NewLogData -= LogManager_NewLogData;			
			Logging.Log.Add(this.ToString(), "ADXAfterFormHide");

			// see ADXOlForm1_ADXPostMessageReceived()
			this.ADXPostMessage(IntPtr.Zero, IntPtr.Zero); 
		}
		private void ADXOlForm1_ADXCloseButtonClick(object sender, ADXCloseButtonClickEventArgs e)
		{
			Logging.Log.Add(this.ToString(), "User closed the pane");
			letMeShow = false;
		}
		private void ADXOlForm1_ADXInspectorActivate(object sender, ADXInspectorActivateEventArgs args)
		{
			Logging.Log.Add(this.ToString(), "ADXInspectorActivate");
		}
		private void ADXOlForm1_ADXSelectionChange()
		{
			Logging.Log.Add(this.ToString(), "ADXSelectionChange" + ". Visible=" + this.Visible.ToString() + ". Active=" + this.Active.ToString());
		}
		private void ADXOlForm1_ADXPostMessageReceived(object sender, AddinExpress.OL.ADXPostMessageReceivedEventArgs e)
		{
			if (e.WParam == IntPtr.Zero && e.LParam == IntPtr.Zero)
			{
				Logging.Log.Add(this.ToString(), "ADXPostMessageReceived. Visibility");
				logPaneManager.PaneVisibilityChanged(this); // updates Ribbon controls showing/hiding the pane
			}
			if (e.WParam == IntPtr.Zero && e.LParam == (IntPtr)1)
			{
				Logging.Log.Add(this.ToString(), "ADXPostMessageReceived. Getting log records");
				this.listBox1.Items.Clear();
				int lastIndex = -1;
				foreach (Logging.LogRecord item in logPaneManager.GetRecords())
				{
					lastIndex = this.listBox1.Items.Add(item.ToString());
				}
				if (lastIndex >= 0) listBox1.SelectedIndex = lastIndex;
				logPaneManager.NewLogData += LogManager_NewLogData;
				Logging.Log.Add(this.ToString(), "ADXPostMessageReceived." + lastIndex.ToString() + " log records proccessed");
			}
		}
		#endregion

		#region Log event
		private void LogManager_NewLogData(object sender, Logging.LogRecord e)
		{
			this.listBox1.Items.Add(e.ToString());
		}
        #endregion 

        #region Clear and Copy
        private void buttonClear_Click(object sender, EventArgs e)
		{
			Logging.Log.Add(this.ToString(), "buttonClear_Click");
			this.listBox1.Items.Clear();
		}

		private void buttonCopy_Click(object sender, EventArgs e)
		{
			Logging.Log.Add(this.ToString(), "buttonCopy_Click");
			System.Windows.Forms.Clipboard.SetText(listBox1.Items[listBox1.SelectedIndex].ToString());
		}
		#endregion

		#region ILogPane implementation
		Logging.ILogPaneManager logPaneManager;

		bool Logging.ILogPane.IsPaneShown { get { return letMeShow; } }
		void Logging.ILogPane.Show() { letMeShow = true; this.Show(); }
		void Logging.ILogPane.Hide() { letMeShow = false; this.Hide(); }
        #endregion ILogPane

        public override string ToString()
        {
			return "ADXOlForm1. id=" + id.ToString();

		}
    }
}
