﻿using System;
using System.Collections.Generic;

namespace Logging
{
    class Log
    {
        private static Log instance = null;
        public static Log Instance
        {
            get
            {
                if (instance == null)
                {
                    instance = new Log();
                }
                return instance;
            }
        }

        private readonly Dictionary<int, LogRecord> dictionary = new Dictionary<int, LogRecord>();
        public event EventHandler<LogRecord> NewData;

        public List<LogRecord> GetData()
        {
            LogRecord[] arr = new LogRecord[dictionary.Count];
            dictionary.Values.CopyTo(arr, 0);
            List<LogRecord> list = new List<LogRecord>(arr);
            return list;
        }

        private Log() {}

        public static void Add(string source, string message)
        {
            LogRecord args = new LogRecord(source, message);
            Instance.dictionary.Add(Instance.dictionary.Count, args);
            if (Instance.NewData != null) Instance.NewData(Instance, args);
            
        }
        public static void Add(string source, Exception ex)
        {
            LogRecord args = new LogRecord(source, ex.ToString());
            Instance.dictionary.Add(Instance.dictionary.Count, args);
            if (Instance.NewData != null) Instance.NewData(Instance, args);
        }
    }
}
