using Outlook = Microsoft.Office.Interop.Outlook;

namespace MyOutlookAddin1
{
	/// <summary>
	/// Add-in Express Outlook Items Events Class
	/// </summary>
	public class OutlookItemsEventsClass1 : AddinExpress.MSO.ADXOutlookItemsEvents
	{
		public OutlookItemsEventsClass1(AddinExpress.MSO.ADXAddinModule module)
			: base(module)
		{
		}

		public override void ProcessItemAdd(object item)
		{
			string subject = 
				(string)item.GetType().InvokeMember("Subject", 
				System.Reflection.BindingFlags.GetProperty, null, item, null);
			string folderName = (this.FolderObj as Outlook.MAPIFolder).Name;
			string format = "The item with subject '{0}' has been added to the folder {1}";
			string message = string.Format(format, subject, folderName);
			Logging.Log.Add("OutlookItemsEventsClass1.ProcessItemAdd", message);
		}

		public override void ProcessItemChange(object item)
		{
			// TODO: Add some code
		}

		public override void ProcessItemRemove()
		{
			// TODO: Add some code
		}
	}
}
